//iwantout
//
//a short puzzle game for Ludum Dare 38 (compo)
//by Zsolt Bartok
//http://www.zsoltbartok.com/
//**************************

var spriteSheet = new Image();
spriteSheet.addEventListener("load", game);
spriteSheet.src = "Iwantout/spriteSheet.png";

var canvas = document.getElementById("iwantoutCanvas");
var ctx = canvas.getContext("2d");

function game()
{
var gameStarted = false;
var rnd = 0;
var showHighlight = false;
var letter = "z";
var letterPrev = "z";
var letterClicked = "z";
var steamCount = 0;
var steamFrame = 0;
var isTyping = false;
var monitorCount = 0;
var code = "z";
var typeCount = 0;
var typeFrame = 0;
var showEnding = false;
var endCount = 0;
var endFrame = 1;
var explCount = 0;
var explFrame = 1;
var showExplosion = false;
var showBroken = false;
var gameOver = false;
var overCount = 0;

var bleepA = document.getElementById("audioA");
var bleepB = document.getElementById("audioB");
var bleepC = document.getElementById("audioC");


function mainLoop() 
	{
	window.requestAnimationFrame(mainLoop);
	
	if (gameStarted == false) {drawIntro();}
	if (gameStarted == true && gameOver == false)
		{
		drawBackground();
		drawFlicker();
		if (showEnding == false) 
			{
			drawMan();
			drawSteam();
			}
		
		if (isTyping == true) {drawLetter();}
		if (code != "z") {drawDots();}
		
		if (showHighlight == true) {drawHighlight();}
		
		if (showBroken == true) {drawBroken();}
		if (showExplosion == true) {drawExplosion();}
		if (showEnding == true) {drawEnding();}
		
		//ctx.fillStyle = "black";
		//ctx.fillText(code, 20,20);
		//ctx.fillText(letter, 20,50);
		}
	if (gameOver == true) {drawOver();}
	}
	
function drawIntro()
	{
	ctx.clearRect(0,0,canvas.width,canvas.height);
	
	ctx.fillStyle = "#202020";
	ctx.fillRect(0,0,canvas.width,canvas.height);
	ctx.drawImage(spriteSheet, 480,225, 232,30, 124,120, 232,30);
	ctx.drawImage(spriteSheet, 480,258, 140,22, 170,240, 140,22);
	}
	
function drawOver()
	{
	ctx.clearRect(0,0,canvas.width,canvas.height);
	
	ctx.fillStyle = "#202020";
	ctx.fillRect(0,0,canvas.width,canvas.height);
	ctx.drawImage(spriteSheet, 640,257, 180,15, 150,120, 180,15);
	}
	
function drawEnding()
	{
	endCount += 1;
	if (endCount >= 5)
		{
		endCount = 0;
		endFrame += 1;
		if (endFrame >= 26) {endFrame = 26;}
		}
	var fy = Math.ceil(endFrame / 8);
	var fx = endFrame - ((fy-1)*8);
	
	if (endFrame > 7)
		{
		ctx.fillStyle = "#a37872";
		ctx.fillRect(170,145, 15,10);
		}
	if (endFrame >= 23) {showExplosion = true;}
	if (endFrame == 23) {bleepC.play();}
	ctx.drawImage(spriteSheet, (fx*115)-115, 170+(fy*100), 115,100, 180,95, 115,100);
	}
	
function drawExplosion()
	{
	explCount += 1;
	if (explCount >= 5)
		{
		explCount = 0;
		explFrame += 1;
		if (explFrame >= 6) 
			{
			showExplosion = false;
			showBroken = true;
			}
		}
	ctx.drawImage(spriteSheet, 190+(explFrame*110), 580, 110,90, 175,60, 110,90);
	}

function drawBackground()
	{
	ctx.clearRect(0,0,canvas.width,canvas.height);
	ctx.drawImage(spriteSheet, 0,0, 480,270, 0,0, 480,270);
	}
	
function drawFlicker()
	{
	rnd = Math.floor((Math.random() * 10) + 1);
	if (rnd > 8)
		{
		ctx.drawImage(spriteSheet, 480,25, 40,25, 210,95, 40,25);
		}
	}
	
function drawBroken()
	{
	ctx.drawImage(spriteSheet, 880,610, 50,45, 205,90, 50,45);
	
	overCount += 1;
	if (overCount >= 50) {gameOver = true;}
	}
	
function drawSteam()
	{
	steamCount += 1;
	if (steamCount >= 20)
		{
		steamCount = 0;
		steamFrame += 1;
		if (steamFrame > 4) {steamFrame = 0;}
		}
	ctx.drawImage(spriteSheet, 535+(steamFrame*15),205, 15,20, 170,125, 15,20);
	}
	
function drawMan()
	{
	if (isTyping == false) {ctx.drawImage(spriteSheet, 520,0, 44,64, 240,120, 44,64);}
	else
		{
		typeCount += 1;
		if (typeCount >= 5)
			{
			typeCount = 0;
			typeFrame += 1;
			if (typeFrame > 2) {typeFrame = 0}
			}
		ctx.drawImage(spriteSheet, 520,(typeFrame*65), 44,64, 240,120, 44,64);
		}
		
	}
	
function drawLetter()
	{
	monitorCount += 1;
	if (monitorCount > 30)
		{
		monitorCount = 0;
		isTyping = false;
		if (code.length == 8) {code = "z";}
		}
	if (letterClicked == "i") {ctx.drawImage(spriteSheet, 480,50, 40,25, 210,95, 40,25);}
	if (letterClicked == "w") {ctx.drawImage(spriteSheet, 480,75, 40,25, 210,95, 40,25);}
	if (letterClicked == "a") {ctx.drawImage(spriteSheet, 480,100, 40,25, 210,95, 40,25);}
	if (letterClicked == "n") {ctx.drawImage(spriteSheet, 480,125, 40,25, 210,95, 40,25);}
	if (letterClicked == "t") {ctx.drawImage(spriteSheet, 480,150, 40,25, 210,95, 40,25);}
	if (letterClicked == "o") {ctx.drawImage(spriteSheet, 480,175, 40,25, 210,95, 40,25);}
	if (letterClicked == "u") {ctx.drawImage(spriteSheet, 480,200, 40,25, 210,95, 40,25);}
	}
	
function drawDots()
	{
	ctx.fillStyle = "#a37872";
	ctx.fillRect(210,95, code.length*5,5);
	}
	
function clicked()
	{
	if (gameStarted == false) {gameStarted = true;}
	
	if (isTyping == false && letter != "z") 
		{
		letterClicked = letter;
		isTyping = true;
		if (code.length > 1 && code.length < 8) {code += letterClicked;}
		if (code.length == 1 && code != "z") {code += letterClicked;}
		if (code.length == 1 && code == "z") {code = letterClicked;}
		
		if (code.length == 8)
			{
			if (code == "iwantout")
				{
				//player wins
				showEnding = true;
				}
			}
		
		bleepA.play();
		}
	}
	
	
function drawHighlight()
	{
	if (letter == "i") {ctx.drawImage(spriteSheet, 520,210, 15,15, 275,110, 15,15);}
	if (letter == "w") {ctx.drawImage(spriteSheet, 520,210, 15,15, 200,135, 15,15);}
	if (letter == "a") {ctx.drawImage(spriteSheet, 520,210, 15,15, 265,95, 15,15);}
	if (letter == "n") {ctx.drawImage(spriteSheet, 520,210, 15,15, 185,115, 15,15);}
	if (letter == "t") {ctx.drawImage(spriteSheet, 520,210, 15,15, 265,105, 15,15);}
	if (letter == "o") {ctx.drawImage(spriteSheet, 520,210, 15,15, 180,100, 15,15);}
	if (letter == "u") {ctx.drawImage(spriteSheet, 520,210, 15,15, 175,120, 15,15);}
	}
	
	
function hovered(e) 
	{
    var posx = e.clientX - canvas.offsetLeft;
	var posy = e.clientY - canvas.offsetTop;
	
	letter = "z";
	if (posx >= 270 && posx <= 289 && posy >= 105 && posy <= 124) {letter = "i";}
	if (posx >= 195 && posx <= 214 && posy >= 130 && posy <= 149) {letter = "w";}
	if (posx >= 260 && posx <= 279 && posy >= 90 && posy <= 104) {letter = "a";}
	if (posx >= 185 && posx <= 199 && posy >= 115 && posy <= 129) {letter = "n";}
	if (posx >= 270 && posx <= 279 && posy >= 105 && posy <= 119) {letter = "t";}
	if (posx >= 175 && posx <= 194 && posy >= 100 && posy <= 114) {letter = "o";}
	if (posx >= 180 && posx <= 189 && posy >= 120 && posy <= 134) {letter = "u";}
	
		
	if (letter != "z") 
		{
		showHighlight = true;
		if (letterPrev != letter)
			{
			bleepB.play();
			letterPrev = letter;
			}
		
		} 
	else {showHighlight = false;}
    }
	

	
canvas.addEventListener("mousedown", clicked);
document.addEventListener("mousemove", hovered);
mainLoop();
}